Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 210575 - doins -r is painfully slow
Summary: doins -r is painfully slow
Status: RESOLVED FIXED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core - Ebuild Support (show other bugs)
Hardware: All Linux
: Highest enhancement (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords: InVCS
Depends on:
Blocks: 216231
  Show dependency tree
 
Reported: 2008-02-18 10:59 UTC by Benedikt Böhm (RETIRED)
Modified: 2010-09-23 02:03 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
patch to remove recursive doins call (doins.diff,990 bytes, patch)
2008-02-18 16:31 UTC, Benedikt Böhm (RETIRED)
Details | Diff
faster doins that should work with spaces (doins.diff,1.44 KB, patch)
2008-02-19 07:48 UTC, Benedikt Böhm (RETIRED)
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Benedikt Böhm (RETIRED) gentoo-dev 2008-02-18 10:59:41 UTC
the current approach for doins -r is painfully slow and should be replaced with cp -R, find|xargs cp, or something similar ...
Comment 1 SpanKY gentoo-dev 2008-02-18 14:53:38 UTC
propose a patch that actually works then ... your suggestions dont as subdirs will break with find|xargs cp, and both will break by not respecting $INSOPTIONS
Comment 2 Benedikt Böhm (RETIRED) gentoo-dev 2008-02-18 16:31:09 UTC
Created attachment 143885 [details, diff]
patch to remove recursive doins call

this reduces `doins -r` time by about 6x on my machine
Comment 3 Benedikt Böhm (RETIRED) gentoo-dev 2008-02-18 16:33:06 UTC
oops, it doesn't handle symlink recursivly, needs another for f in $(find ..) ..
Comment 4 SpanKY gentoo-dev 2008-02-18 23:46:58 UTC
i'm pretty sure that's broken with whitespace in the paths, but it's a good first crack
Comment 5 Bo Ørsted Andresen (RETIRED) gentoo-dev 2008-02-18 23:51:08 UTC
(In reply to comment #4)
> i'm pretty sure that's broken with whitespace in the paths, [...]

It is. `for f in $(find -type f)` breaks it.
Comment 6 Benedikt Böhm (RETIRED) gentoo-dev 2008-02-19 07:48:51 UTC
Created attachment 143938 [details, diff]
faster doins that should work with spaces
Comment 7 SpanKY gentoo-dev 2008-02-19 17:21:42 UTC
while you're in there, you should convert basename/dirname to the bash equivalents

errors also need to be passed back up (from `install` and `cp`)
Comment 8 Arfrever Frehtes Taifersar Arahesis (RETIRED) gentoo-dev 2008-03-20 18:03:04 UTC
Fixed in r9485 and released in sys-apps/portage-2.2_pre5.

This bug should be RESOLVED FIXED and block bug #210077.
Comment 9 Marius Mauch (RETIRED) gentoo-dev 2008-03-20 18:14:58 UTC
This is supposed to be fixed in portage-2.2_pre5 or earlier.
Comment 10 Marius Mauch (RETIRED) gentoo-dev 2008-03-20 18:15:44 UTC
This is supposed to be fixed in portage-2.2_pre5 or earlier.
Comment 11 Jeroen Roovers (RETIRED) gentoo-dev 2010-08-28 04:40:58 UTC
(In reply to comment #8)
> This bug should be RESOLVED FIXED and block bug #210077.

It really should. "Painfully" doesn't quite catch the feeling you get
 while
  the
   parade
    of
     tentacled
      minutes
       crawls
        by
         on
          its
           millions
            of
             spidery
              legs.